App Service Environments - List
Description for Get all App Service Environments for a subscription.
GET https://management.azure.com/subscriptions/{subscriptionId}/providers/Microsoft.Web/hostingEnvironments?api-version=2025-05-01
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
|
subscription
|
path | True |
string (uuid) |
The ID of the target subscription. The value must be an UUID. |
|
api-version
|
query | True |
string minLength: 1 |
The API version to use for this operation. |
Responses
| Name | Type | Description |
|---|---|---|
| 200 OK |
Azure operation completed successfully. |
|
| Other Status Codes |
An unexpected error response. |
Security
azure_auth
Azure Active Directory OAuth2 Flow.
Type:
oauth2
Flow:
implicit
Authorization URL:
https://login.microsoftonline.com/common/oauth2/authorize
Scopes
| Name | Description |
|---|---|
| user_impersonation | impersonate your user account |
Examples
Get all App Service Environments for a subscription.
Sample request
Sample response
{
"value": [
{
"name": "test-ase",
"type": "Microsoft.Web/hostingEnvironments",
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/test-rg/providers/Microsoft.Web/hostingEnvironments/test-ase",
"kind": "ASEV3",
"location": "South Central US",
"properties": {
"clusterSettings": null,
"dedicatedHostCount": 0,
"dnsSuffix": "test-ase.p.azurewebsites.net",
"frontEndScaleFactor": 15,
"hasLinuxWorkers": true,
"internalLoadBalancingMode": "None",
"ipsslAddressCount": 0,
"maximumNumberOfMachines": 250,
"multiRoleCount": null,
"multiSize": "Standard_D2d_v4",
"networkingConfiguration": {
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/test-rg/providers/Microsoft.Web/hostingEnvironments/test-ase/configurations/networking",
"properties": {
"allowNewPrivateEndpointConnections": false,
"externalInboundIpAddresses": [
"52.153.248.36"
],
"ftpEnabled": false,
"inboundIpAddressOverride": null,
"internalInboundIpAddresses": [],
"linuxOutboundIpAddresses": [
"20.88.241.56",
"20.88.241.9"
],
"remoteDebugEnabled": false,
"windowsOutboundIpAddresses": [
"20.88.241.56",
"20.88.241.9"
]
}
},
"provisioningState": "Succeeded",
"status": "Ready",
"suspended": false,
"userWhitelistedIpRanges": null,
"virtualNetwork": {
"name": "delegated",
"type": "Microsoft.Network/virtualNetworks/subnets",
"id": "/subscriptions/34adfa4f-cedf-4dc0-ba29-b6d1a69ab345/resourceGroups/test-rg/providers/Microsoft.Network/virtualNetworks/test-subnet/subnets/delegated",
"subnet": ""
},
"zoneRedundant": false
},
"tags": {}
}
]
}
Definitions
| Name | Description |
|---|---|
|
App |
Collection of App Service Environments. |
|
App |
App Service Environment ARM resource. |
|
AseV3Networking |
Full view of networking configuration for an ASE. |
|
created |
The type of identity that created the resource. |
|
Custom |
Full view of the custom domain suffix configuration for ASEv3. |
|
Custom |
|
|
Default |
App Service error response. |
|
Default |
Error model. |
|
Default |
Detailed errors. |
|
Hosting |
Current status of the App Service Environment. |
|
Load |
Specifies which endpoints to serve internally in the Virtual Network for the App Service Environment. |
|
Name |
Name value pair. |
|
Provisioning |
Provisioning state of the App Service Plan. |
|
system |
Metadata pertaining to creation and last modification of the resource. |
|
Upgrade |
Whether an upgrade is available for this App Service Environment. |
|
Upgrade |
Upgrade Preference |
|
Virtual |
Specification for using a Virtual Network. |
AppServiceEnvironmentCollection
Collection of App Service Environments.
| Name | Type | Description |
|---|---|---|
| nextLink |
string (uri) |
The link to the next page of items |
| value |
The AppServiceEnvironmentResource items on this page |
AppServiceEnvironmentResource
App Service Environment ARM resource.
| Name | Type | Default value | Description |
|---|---|---|---|
| id |
string (arm-id) |
Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}" |
|
| kind |
string |
Kind of resource. If the resource is an app, you can refer to https://github.com/Azure/app-service-linux-docs/blob/master/Things_You_Should_Know/kind_property.md#app-service-resource-kind-reference for details supported values for kind. |
|
| location |
string |
The geo-location where the resource lives |
|
| name |
string |
The name of the resource |
|
| properties.clusterSettings |
Custom settings for changing the behavior of the App Service Environment. |
||
| properties.customDnsSuffixConfiguration |
Full view of the custom domain suffix configuration for ASEv3. |
||
| properties.dedicatedHostCount |
integer (int32) |
Dedicated Host Count |
|
| properties.dnsSuffix |
string |
DNS suffix of the App Service Environment. |
|
| properties.frontEndScaleFactor |
integer (int32) |
Scale factor for front-ends. |
|
| properties.hasLinuxWorkers |
boolean |
Flag that displays whether an ASE has linux workers or not |
|
| properties.internalLoadBalancingMode |
Specifies which endpoints to serve internally in the Virtual Network for the App Service Environment. |
||
| properties.ipsslAddressCount |
integer (int32) |
Number of IP SSL addresses reserved for the App Service Environment. |
|
| properties.maximumNumberOfMachines |
integer (int32) |
Maximum number of VMs in the App Service Environment. |
|
| properties.multiRoleCount |
integer (int32) |
Number of front-end instances. |
|
| properties.multiSize |
string |
Front-end VM size, e.g. "Medium", "Large". |
|
| properties.networkingConfiguration |
Full view of networking configuration for an ASE. |
||
| properties.provisioningState |
Provisioning state of the App Service Environment. |
||
| properties.status |
Current status of the App Service Environment. |
||
| properties.suspended |
boolean |
|
|
| properties.upgradeAvailability |
Whether an upgrade is available for this App Service Environment. |
||
| properties.upgradePreference | None |
Upgrade Preference |
|
| properties.userWhitelistedIpRanges |
string[] |
User added ip ranges to whitelist on ASE db |
|
| properties.virtualNetwork |
Description of the Virtual Network. |
||
| properties.zoneRedundant |
boolean |
Whether or not this App Service Environment is zone-redundant. |
|
| systemData |
Azure Resource Manager metadata containing createdBy and modifiedBy information. |
||
| tags |
object |
Resource tags. |
|
| type |
string |
The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts" |
AseV3NetworkingConfiguration
Full view of networking configuration for an ASE.
| Name | Type | Description |
|---|---|---|
| id |
string (arm-id) |
Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}" |
| kind |
string |
Kind of resource. |
| name |
string |
The name of the resource |
| properties.allowNewPrivateEndpointConnections |
boolean |
Property to enable and disable new private endpoint connection creation on ASE |
| properties.externalInboundIpAddresses |
string[] |
|
| properties.ftpEnabled |
boolean |
Property to enable and disable FTP on ASEV3 |
| properties.inboundIpAddressOverride |
string |
Customer provided Inbound IP Address. Only able to be set on Ase create. |
| properties.internalInboundIpAddresses |
string[] |
|
| properties.linuxOutboundIpAddresses |
string[] |
|
| properties.remoteDebugEnabled |
boolean |
Property to enable and disable Remote Debug on ASEV3 |
| properties.windowsOutboundIpAddresses |
string[] |
|
| systemData |
Azure Resource Manager metadata containing createdBy and modifiedBy information. |
|
| type |
string |
The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts" |
createdByType
The type of identity that created the resource.
| Value | Description |
|---|---|
| User | |
| Application | |
| ManagedIdentity | |
| Key |
CustomDnsSuffixConfiguration
Full view of the custom domain suffix configuration for ASEv3.
| Name | Type | Description |
|---|---|---|
| id |
string (arm-id) |
Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}" |
| kind |
string |
Kind of resource. |
| name |
string |
The name of the resource |
| properties.certificateUrl |
string |
The URL referencing the Azure Key Vault certificate secret that should be used as the default SSL/TLS certificate for sites with the custom domain suffix. |
| properties.dnsSuffix |
string |
The default custom domain suffix to use for all sites deployed on the ASE. |
| properties.keyVaultReferenceIdentity |
string |
The user-assigned identity to use for resolving the key vault certificate reference. If not specified, the system-assigned ASE identity will be used if available. |
| properties.provisioningDetails |
string |
|
| properties.provisioningState | ||
| systemData |
Azure Resource Manager metadata containing createdBy and modifiedBy information. |
|
| type |
string |
The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts" |
CustomDnsSuffixProvisioningState
| Value | Description |
|---|---|
| Succeeded | |
| Failed | |
| Degraded | |
| InProgress |
DefaultErrorResponse
App Service error response.
| Name | Type | Description |
|---|---|---|
| error |
Error model. |
DefaultErrorResponseError
Error model.
| Name | Type | Description |
|---|---|---|
| code |
string |
Standardized string to programmatically identify the error. |
| details |
Detailed errors. |
|
| innererror |
string |
More information to debug error. |
| message |
string |
Detailed error description and debugging information. |
| target |
string |
Detailed error description and debugging information. |
DefaultErrorResponseErrorDetailsItem
Detailed errors.
| Name | Type | Description |
|---|---|---|
| code |
string |
Standardized string to programmatically identify the error. |
| message |
string |
Detailed error description and debugging information. |
| target |
string |
Detailed error description and debugging information. |
HostingEnvironmentStatus
Current status of the App Service Environment.
| Value | Description |
|---|---|
| Preparing | |
| Ready | |
| Scaling | |
| Deleting |
LoadBalancingMode
Specifies which endpoints to serve internally in the Virtual Network for the App Service Environment.
| Value | Description |
|---|---|
| None | |
| Web | |
| Publishing | |
| Web, Publishing |
NameValuePair
Name value pair.
| Name | Type | Description |
|---|---|---|
| name |
string |
Pair name. |
| value |
string |
Pair value. |
ProvisioningState
Provisioning state of the App Service Plan.
| Value | Description |
|---|---|
| Succeeded | |
| Failed | |
| Canceled | |
| InProgress | |
| Deleting |
systemData
Metadata pertaining to creation and last modification of the resource.
| Name | Type | Description |
|---|---|---|
| createdAt |
string (date-time) |
The timestamp of resource creation (UTC). |
| createdBy |
string |
The identity that created the resource. |
| createdByType |
The type of identity that created the resource. |
|
| lastModifiedAt |
string (date-time) |
The timestamp of resource last modification (UTC) |
| lastModifiedBy |
string |
The identity that last modified the resource. |
| lastModifiedByType |
The type of identity that last modified the resource. |
UpgradeAvailability
Whether an upgrade is available for this App Service Environment.
| Value | Description |
|---|---|
| None |
No upgrade is currently available for this App Service Environment |
| Ready |
An upgrade is ready to be manually initiated on this App Service Environment |
UpgradePreference
Upgrade Preference
| Value | Description |
|---|---|
| None |
No preference on when this App Service Environment will be upgraded |
| Early |
This App Service Environment will be upgraded before others in the same region that have Upgrade Preference 'Late' |
| Late |
This App Service Environment will be upgraded after others in the same region that have Upgrade Preference 'Early' |
| Manual |
ASEv3 only. Once an upgrade is available, this App Service Environment will wait 10 days for the upgrade to be manually initiated. After 10 days the upgrade will begin automatically |
VirtualNetworkProfile
Specification for using a Virtual Network.
| Name | Type | Description |
|---|---|---|
| id |
string |
Resource id of the Virtual Network. |
| name |
string |
Name of the Virtual Network (read-only). |
| subnet |
string |
Subnet within the Virtual Network. |
| type |
string |
Resource type of the Virtual Network (read-only). |